Index: /trunk/gli/src/org/greenstone/gatherer/gems/MSMUtils.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/gems/MSMUtils.java	(revision 8970)
+++ /trunk/gli/src/org/greenstone/gatherer/gems/MSMUtils.java	(revision 8971)
@@ -44,4 +44,5 @@
 import org.greenstone.gatherer.util.StaticStrings;
 import org.greenstone.gatherer.util.Utility;
+import org.greenstone.gatherer.util.XMLTools;
 import org.w3c.dom.*;
 /** This class contains a plethora of methods associated with handling the content of <strong>MetadataSet</strong>s and the <strong>Element</strong>s within. For example this is where you will find methods for comparing various parts of two <strong>MetadataSet</strong>s for equality. It also has methods for extracting common and useful data from <strong>Element</strong>s such as the AssignedValue nodes.
@@ -93,11 +94,13 @@
 	attribute_element.setAttribute(StaticStrings.NAME_ATTRIBUTE, attribute_name_str);
 	MSMUtils.setValue(attribute_element, value_str);
+
 	// Start off by determining if we have to add this node in the new multilingual optimized way
 	if(isAttributeLanguageDependant(document, attribute_name_str)) {
 	    boolean found = false;
 	    // Try to retrieve a language element for the given language code
-	    NodeList language_elements = element_element.getElementsByTagName(StaticStrings.LANGUAGE_ELEMENT);
-	    for(int i = 0; i < language_elements.getLength(); i++) {
-		Element language_element = (Element) language_elements.item(i);
+	    //NodeList language_elements = element_element.getElementsByTagName(StaticStrings.LANGUAGE_ELEMENT);
+	    ArrayList language_elements = XMLTools.getChildElementsByTagName(element_element, StaticStrings.LANGUAGE_ELEMENT);
+	    for(int i = 0; i < language_elements.size(); i++) {
+		Element language_element = (Element) language_elements.get(i);
 		if(language_element.getAttribute(StaticStrings.CODE_ATTRIBUTE).equals(language_code_str)) {
 		    found = true;
@@ -736,9 +739,22 @@
      * @param attribute_name_str the name of the attribute we a testing as a String
      * @see org.greenstone.gatherer.util.StaticStrings#LANGUAGEDEPENDANT_ATTRIBUTE
+     * Modified by Matthew Whyte 4/02/05
      */
     static private boolean isAttributeLanguageDependant(Document document, String attribute_name_str)
     {
+	//gives a list of comma seperated language specific attributes.
 	String language_specific_attributes = document.getDocumentElement().getAttribute(StaticStrings.LANGUAGEDEPENDANT_ATTRIBUTE).toLowerCase();
-	return language_specific_attributes.indexOf(attribute_name_str) != -1;
+	//System.err.println("lang_specific: " + language_specific_attributes); //debug
+
+	//Seperate out language_specific_attributes
+	String[] attributes_split = language_specific_attributes.split(",");
+
+	//Compare each to attribute_name_str
+	for(int i = 0; i < attributes_split.length; i++)
+	    {
+		if(attributes_split[i].trim().compareTo(attribute_name_str.toLowerCase()) == 0)
+		    return true;
+	    }
+	return false;
     }
 
@@ -802,45 +818,67 @@
      */
     static public boolean removeElementAttribute(Element element_element, String attribute_name_str, String language_code_str, String value_str) {
-	// Multilingual Optimized version
-	// 1. Determine the if this is one of the language specific attributes
-	if(isAttributeLanguageDependant(element_element.getOwnerDocument(), attribute_name_str)) {
-	    // Retrieve the language elements, and determine the correct one
-	    NodeList language_elements = element_element.getElementsByTagName(StaticStrings.LANGUAGE_ELEMENT);
-	    for(int i = 0; i < language_elements.getLength(); i++) {
-		Element language_element = (Element) language_elements.item(i);
-		if(language_element.getAttribute(StaticStrings.CODE_ATTRIBUTE).equalsIgnoreCase(language_code_str)) {
-		    NodeList attribute_elements = language_element.getElementsByTagName(StaticStrings.ATTRIBUTE_ELEMENT);
-		    for(int j = 0; j < attribute_elements.getLength(); j++) {
-			Element attribute_element = (Element) attribute_elements.item(j);
-			String target_name_str = attribute_element.getAttribute(StaticStrings.NAME_ATTRIBUTE);
-			String target_value_str = MSMUtils.getValue(attribute_element);
-			if(attribute_name_str.equals(target_name_str) && value_str.equals(target_value_str)) {
-			    language_element.removeChild(attribute_element);
-			    if(attribute_elements.getLength() == 0) {
-				element_element.removeChild(language_element);
-			    }
-			    target_value_str = null;
-			    target_name_str = null;
-			    attribute_element = null;
-			    attribute_elements = null;
-			    language_element = null;
-			    language_elements = null;
-			    return true;
+	//Determine the if this is one of the language specific attributes.
+	//This can sometimes give a false result, if an attribute is made language specific half way through creation of a metadata set (or vice versa).
+	if(isAttributeLanguageDependant(element_element.getOwnerDocument(), attribute_name_str))
+	    {
+		/*
+		Multilingual Optimized version, eg:
+		<Language code="en">
+		    <Attribute name="identifier">second</Attribute>
+		</Language>
+		*/
+		return removeElementAttributeNew(element_element, attribute_name_str, language_code_str, value_str, false);
+	    }
+	else
+	    {
+		/*
+		The old way, eg:
+		<Attribute language="en" name="identifier">second</Attribute>
+		*/
+		return removeElementAttributeOld(element_element, attribute_name_str, language_code_str, value_str, false);
+	    }
+	
+    }
+    static final private boolean removeElementAttributeNew(Element element_element, String attribute_name_str, String language_code_str, String value_str, boolean run_once)
+    {
+	// Retrieve the language elements, and determine the correct one
+	NodeList language_elements = element_element.getElementsByTagName(StaticStrings.LANGUAGE_ELEMENT);
+	for(int i = 0; i < language_elements.getLength(); i++) {
+	    Element language_element = (Element) language_elements.item(i);
+	    if(language_element.getAttribute(StaticStrings.CODE_ATTRIBUTE).equalsIgnoreCase(language_code_str)) {
+		NodeList attribute_elements = language_element.getElementsByTagName(StaticStrings.ATTRIBUTE_ELEMENT);
+		for(int j = 0; j < attribute_elements.getLength(); j++) {
+		    Element attribute_element = (Element) attribute_elements.item(j);
+		    String target_name_str = attribute_element.getAttribute(StaticStrings.NAME_ATTRIBUTE);
+		    String target_value_str = MSMUtils.getValue(attribute_element);
+		    if(attribute_name_str.equals(target_name_str) && value_str.equals(target_value_str)) {
+			language_element.removeChild(attribute_element);
+			if(attribute_elements.getLength() == 0) {
+			    element_element.removeChild(language_element);
 			}
 			target_value_str = null;
 			target_name_str = null;
-			attribute_element = null;			
+			attribute_element = null;
+			attribute_elements = null;
+			language_element = null;
+			language_elements = null;
+			return true;
 		    }
-		    attribute_elements = null;
-		}
-		language_element = null;
-	    }
-	    language_elements = null;
-	    // Not found
-	    //System.err.println("new optimised way failed."); //debug
-	    return false;
-	} // end if
-	// Otherwise just use the old method
-
+		    target_value_str = null;
+		    target_name_str = null;
+		    attribute_element = null;			
+		}
+		attribute_elements = null;
+	    }
+	    language_element = null;
+	}
+	language_elements = null;
+	// Not found. Try the old way before failing.
+	if(!run_once)
+	    return removeElementAttributeOld(element_element, attribute_name_str, language_code_str, value_str, true);
+	return false;
+    }
+    static final private boolean removeElementAttributeOld(Element element_element, String attribute_name_str, String language_code_str, String value_str, boolean run_once)
+    {
 	// Find the attribute to remove
 	NodeList attribute_elements = element_element.getElementsByTagName(StaticStrings.ATTRIBUTE_ELEMENT);
@@ -858,6 +896,7 @@
 	}
 	attribute_elements = null;
-	// No match found
-	//System.err.println("Old method failed."); //debug
+	// No match found. Try the new way before failing.
+	if(!run_once)
+	    return removeElementAttributeNew(element_element, attribute_name_str, language_code_str, value_str, true);
 	return false;
     }
Index: /trunk/gli/src/org/greenstone/gatherer/gems/MetadataSet.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/gems/MetadataSet.java	(revision 8970)
+++ /trunk/gli/src/org/greenstone/gatherer/gems/MetadataSet.java	(revision 8971)
@@ -496,10 +496,7 @@
     /** Method to remove the given element from this metadata set.
      * @param element The <strong>Element</strong> to be removed.
-     * @param parent The parent element, as an <strong>Element</strong>. If null, the parent is root.
-     */
-    public void removeElement(Element element, Element parent) {
-	// we need to remove the value tree too!!
-	//System.err.println("removeElement in MetadataSet: element is: " + element); //Debug
-
+     * @param parent The parent element (wrapped, so can access its subelement list), as an <strong>ElementWrapper</strong>. If null, the parent is root.
+     */
+    public void removeElement(Element element, ElementWrapper parent) {
 	try {
 	    ElementWrapper element_wrapped = new ElementWrapper(element);
@@ -508,10 +505,12 @@
 	    if(parent == null)
 		{
-		    parent = root;
+		    elements.remove(element);
+		    root.removeChild(element);
 		}
-	    
-	    //Want to remove subelement.
-	    //System.err.println("Wanna remove subelement"); //debug
-	    parent.removeChild(element);
+	    else
+		{
+		    parent.removeSubelementFromList(element);
+		    parent.getElement().removeChild(element);
+		}
 	    
 	} catch(Exception DOMException) { //The element does not exist!!
Index: /trunk/gli/src/org/greenstone/gatherer/gems/MetadataSetManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/gems/MetadataSetManager.java	(revision 8970)
+++ /trunk/gli/src/org/greenstone/gatherer/gems/MetadataSetManager.java	(revision 8971)
@@ -405,5 +405,4 @@
            if(st.nextToken().compareTo("collect") == 0) {
             colName = st.nextToken();  
-	    System.err.println("colName is: " + colName); //debug
            // metadata_set.old_filename = metadata_set.getName();
            // metadata_set.setName(new String("(" + colName + ") " + metadata_set.getName()) );
@@ -431,4 +430,6 @@
        @return void
        Modified by Matthew Whyte 19/01/04
+
+       This should really be totally replaced by MetadataSet.removeElement --Matthew
      */
     public void removeElement(ElementWrapper element, ElementWrapper parent) {
@@ -439,12 +440,5 @@
 	if(set != null) {
 	    //Remove the element
-	    if(parent == null)
-		{
-		    set.removeElement(element.getElement(), null); //Let's not cause an exception!
-		}
-	    else
-		{
-		    set.removeElement(element.getElement(), parent.getElement());
-		}
+	    set.removeElement(element.getElement(), parent);
 	}
 	else {
@@ -463,6 +457,4 @@
     public void renameElement(ElementWrapper oldElement, String newName)
     {
-	GEMSNode node = null;
-
 	//Retrive the metadata set this element belongs to.
 	String namespace = oldElement.getNamespace();
@@ -491,5 +483,4 @@
 	    for(int i = 0; i < all_values.size(); i++) {
 		GValueNode node = (GValueNode)all_values.get(i);
-		TreePath path = new TreePath(node.getPath());
 		String full_value = node.getFullPath(false);
  		String index = model.getHIndex(full_value);
